<script lang="ts" setup>
import { nextTick, onMounted, ref, watchEffect } from 'vue'
import type { VForm } from 'vuetify/components'
import type { User } from '@/types/User'
import { useUserStore } from '@/stores/user'
import { useRoleStore } from '@/stores/role'
import { useBranchStore } from '@/stores/branch'
const userStore = useUserStore()
const branchStore = useBranchStore()
const headers = [
  {
    title: 'รหัส',
    key: 'id',
    value: 'id'
  },
  {
    title: 'รูปภาพ',
    key: 'image'
  },
  {
    title: 'ชื่อ นามสกุล',
    key: 'name',
    value: 'name'
  },
  {
    title: 'ตำแหน่ง',
    key: 'roles',
    value: (item: any | User) => item.role.name
  },
  {
    title: 'สาขา',
    key: 'branch',
    value: (item: any | User) => item.branch.name
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const roleStore = useRoleStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const newUser = ref(false)
const passwordDialog = ref(false)

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await userStore.deleteUser()
  closeDelete()
}
async function editItem(item: User) {
  console.log('BranchStore:', branchStore.branches)
  if (!item.id) return
  await userStore.getUser(item.id)
  console.log('editeedUser:', userStore.editedUser)
  dialog.value = true
}
async function deleteItem(item: User) {
  if (!item.id) return
  await userStore.getUser(item.id)
  dialogDelete.value = true
}

async function changePassword() {
  await userStore.changePassword()
  passwordDialog.value = false
}

async function onChangePassword(item: User) {
  if (!item.id) return
  await userStore.getUser(item.id)
  passwordDialog.value = true
  console.log('passwordDialog:', passwordDialog.value)
}

function closeDialog() {
  dialog.value = false
  newUser.value = false
  passwordDialog.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  console.log('save:', userStore.editedUser)
  await userStore.saveUser()
  closeDialog()
}

onMounted(async () => {
  await userStore.getUsers()
  await roleStore.getRoles()
  await branchStore.getBranches()
  console.log('user:', userStore.users)
  console.log('roles:', roleStore.roles)
  console.log('branch:', branchStore.branches)
})

const imageURL = ref<any>(null)
watchEffect(() => {
  if (userStore.editedUser.files && userStore.editedUser.files.length > 0) {
    const reader = new FileReader()
    reader.onload = (event) => {
      imageURL.value = event.target?.result
    }
    reader.readAsDataURL(userStore.editedUser.files[0])
  } else {
    imageURL.value = null
  }
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="userStore.users">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>พนักงาน</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                color="primary"
                v-bind="props"
                @click="
                  () => {
                    newUser = true
                    userStore.clearForm()
                  }
                "
              >
                <v-icon> mdi-plus </v-icon>
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">ข้อมูลพนักงาน</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-card title="ประวัติ" variant="outlined">
                      <div
                        style="
                          padding-left: 30px;
                          padding-right: 30px;
                          padding-top: 10px;
                          padding-bottom: 10px;
                        "
                      >
                        <v-row>
                          <v-col cols="12" md="8">
                            <v-row>
                              <v-col cols="12">
                                <v-text-field
                                  v-model="userStore.editedUser.name"
                                  :readonly="loading"
                                  variant="outlined"
                                  label="ชื่อ-นามสกุล"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  class="mb-2"
                                  clearable
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" md="6">
                                <v-text-field
                                  v-model="userStore.editedUser.birthDate"
                                  :readonly="loading"
                                  variant="outlined"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  clearable
                                  label="วันเดือนปีเกิด"
                                  type="Date"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" md="6">
                                <v-text-field
                                  v-model="userStore.editedUser.age"
                                  :readonly="loading"
                                  variant="outlined"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  clearable
                                  label="อายุ"
                                  placeholder="Enter your age"
                                  type="number"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" md="6">
                                <v-combobox
                                  v-model="userStore.editedUser.gender"
                                  clearable
                                  label="เพศ"
                                  :items="['ชาย', 'หญิง', 'อื่นๆ']"
                                  variant="outlined"
                                ></v-combobox>
                              </v-col>
                              <v-col cols="12" md="6">
                                <v-combobox
                                  v-model="userStore.editedUser.bloodType"
                                  clearable
                                  label="หมู่เลือด"
                                  variant="outlined"
                                  :items="['A+', 'A-', 'B+', 'B-', 'AB+', 'AB-', 'O+', 'O-']"
                                ></v-combobox>
                              </v-col>
                              <v-col cols="12" md="6">
                                <v-text-field
                                  v-model="userStore.editedUser.height"
                                  :readonly="loading"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  clearable
                                  label="Height (cm.)"
                                  placeholder="Enter your Height"
                                  type="number"
                                  variant="outlined"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" md="6">
                                <v-text-field
                                  v-model="userStore.editedUser.weight"
                                  :readonly="loading"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  clearable
                                  label="Weight (kg.)"
                                  placeholder="Enter your Weight"
                                  type="number"
                                  variant="outlined"
                                ></v-text-field>
                              </v-col>
                            </v-row>
                          </v-col>
                          <v-col cols="12" md="4">
                            <v-row>
                              <v-img
                                v-if="
                                  userStore.editedUser.files &&
                                  userStore.editedUser.files.length > 0
                                "
                                :src="imageURL"
                                alt="Uploaded Image"
                                width="200"
                                height="200"
                              ></v-img>
                              <v-img
                                v-else
                                :src="
                                  'http://localhost:3000/images/users/' + userStore.editedUser.image
                                "
                                width="200"
                                height="200"
                              >
                              </v-img>
                            </v-row>
                            <v-row>
                              <v-file-input
                                v-model="userStore.editedUser.files"
                                :rules="[
                                  (value) => {
                                    return (
                                      !value ||
                                      !value.length ||
                                      value[0].size < 2000000 ||
                                      'Avatar size should be less than 2 MB!'
                                    )
                                  }
                                ]"
                                accept="image/png, image/jpeg"
                                placeholder="Pick an avatar"
                                prepend-icon="mdi-image"
                                label="Avatar"
                                variant="outlined"
                              ></v-file-input>
                            </v-row>
                          </v-col>
                          <v-row>
                            <v-col cols="12">
                              <v-textarea
                                v-model="userStore.editedUser.address"
                                :readonly="loading"
                                :rules="[(v) => !!v || 'Field is required']"
                                clearable
                                label="ที่อยู่"
                                variant="outlined"
                                placeholder="Enter Address"
                              ></v-textarea>
                            </v-col>
                          </v-row>
                        </v-row>
                      </div>
                    </v-card>

                    <v-card title="ช่องทางการติดต่อ" variant="outlined" style="margin-top: 20px">
                      <div
                        style="
                          padding-left: 30px;
                          padding-right: 30px;
                          padding-top: 10px;
                          padding-bottom: 10px;
                        "
                      >
                        <v-row>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.phone"
                              :readonly="loading"
                              variant="outlined"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="เบอร์โทรศัพท์"
                              placeholder="xxx-xxx-xxxxx"
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.email"
                              :readonly="loading"
                              variant="outlined"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="อีเมล"
                              placeholder="Enter Email"
                              :type="'email'"
                            ></v-text-field>
                          </v-col>
                        </v-row>
                      </div>
                    </v-card>
                    <v-card title="การงาน" variant="outlined" style="margin-top: 20px">
                      <div
                        style="
                          padding-left: 30px;
                          padding-right: 30px;
                          padding-top: 10px;
                          padding-bottom: 10px;
                        "
                      >
                        <v-row>
                          <v-col cols="12" v-if="newUser === true">
                            <v-text-field
                              v-model="userStore.editedUser.password"
                              :readonly="loading"
                              :rules="[(v) => !!v || 'Field is required']"
                              label="รหัสผ่าน เข้าระบบ"
                              placeholder="Enter password"
                              clearable
                              variant="outlined"
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12">
                            <v-combobox
                              v-model="userStore.editedUser.branch"
                              :items="branchStore.branches"
                              item-title="name"
                              item-value="id"
                              label="สาขา"
                              return-object
                              variant="outlined"
                            ></v-combobox>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-combobox
                              v-model="userStore.editedUser.role"
                              :items="roleStore.roles"
                              item-title="name"
                              label="ตำเหน่งงาน"
                              item-value="id"
                              return-object
                              variant="outlined"
                            ></v-combobox>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.salary"
                              :readonly="loading"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="เงินเดือน"
                              placeholder="Enter Salary"
                              type="number"
                              variant="outlined"
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.startDate"
                              :readonly="loading"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="วันที่เข้าทำงาน"
                              variant="outlined"
                              type="Date"
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-combobox
                              v-model="userStore.editedUser.status"
                              clearable
                              label="สถานะ"
                              :items="['ยังอยู่', 'ออกแล้ว']"
                              variant="outlined"
                            ></v-combobox>
                          </v-col>
                        </v-row>
                      </div>
                    </v-card>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="passwordDialog" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">เปลี่ยนรหัสผ่าน</v-card-title>
              <v-card-text>
                <v-row style="padding-top: 10px; padding-bottom: 10px">
                  <strong>email : </strong>
                  {{ userStore.editedUser.email }}
                </v-row>
                <v-form>
                  <v-text-field
                    v-model="userStore.editedUser.password"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    label="รหัสผ่าน เข้าระบบ"
                    placeholder="Enter password"
                    clearable
                    variant="outlined"
                  ></v-text-field>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="changePassword">save</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
        <v-icon size="small" @click="onChangePassword(item)"> mdi-key </v-icon>
      </template>

      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/users/' + item.image" width="100"> </v-img>
      </template>

      <template v-slot:no-data>
        <v-btn color="primary" @click="userStore.getUsers"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
